--- typo3_src-4.0.2/typo3/class.db_list.inc	2006-09-11 09:18:23.000000000 +0200
+++ hooktest/typo3_src-4.0.2/typo3/class.db_list.user	2006-10-10 13:26:53.269041830 +0200
@@ -432,7 +432,18 @@
 	 * @return	array		Returns query array
 	 */
 	function makeQueryArray($table, $id, $addWhere="",$fieldList='*')	{
-		global $TCA;
+// b.k.(citeq) added $TYPO3_CONF_VARS - needed for versioning-hook
+		global $TCA, $TYPO3_CONF_VARS;
+		
+// b.k.(citeq) added initialization of hookObjectsArr
+// First prepare user defined objects (if any) for hooks which extend this function:
+		$hookObjectsArr = array();
+		if (is_array ($TYPO3_CONF_VARS['SC_OPTIONS']['typo3/class.db_list.inc']['makeQueryArray'])) {
+			foreach ($TYPO3_CONF_VARS['SC_OPTIONS']['typo3/class.db_list.inc']['makeQueryArray'] as $classRef) {
+				$hookObjectsArr[] = &t3lib_div::getUserObj($classRef);
+			}
+		}
+
 
 			// Set ORDER BY:
 		$orderBy = ($TCA[$table]['ctrl']['sortby']) ? 'ORDER BY '.$TCA[$table]['ctrl']['sortby'] : $TCA[$table]['ctrl']['default_sortby'];
@@ -453,6 +464,14 @@
 		$search = $this->makeSearchString($table);
 
 			// Compiling query array:
+			
+// b.k.(citeq) hook for versioning, listing of tables related to tx_civserv_services in extension civserv
+		foreach($hookObjectsArr as $hookObj){
+			if (method_exists($hookObj, 'remakeQueryArray')) {
+				$hookObj->remakeQueryArray($table, $id, $this->pidSelect, $fieldList, $addWhere, $orderBy);
+			}
+		}
+
 		$queryParts = array(
 			'SELECT' => $fieldList,
 			'FROM' => $table,
@@ -768,4 +787,4 @@
 if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['typo3/class.db_list.inc'])	{
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['typo3/class.db_list.inc']);
 }
-?>
\ No newline at end of file
+?>
